{XAL:.C5Service}

FUNCTION STR 254 C5Service (STR 30  &CMD, STR 254 &IDATA, BYREF STR 12 &HCOM)
{ͻ}
{ Declare variables                                                        }
{ͼ}
#MacroLoad(COMAPIUTIL)
    STR 12 &HDomDocument

    #Switch(&CMD)

    // 14.05.2014 GSL - Systemconnect. Bugfix efter ny Nationalbank hjemmeside
    #Case('HttpOpenGet')
        IF (&IDATA == '') THEN
            RETURN "0"
        ENDIF

        SET &HCOM = COMCreate(0,'MSXML2.XMLHTTP','',0)
        IF (&HCOM == '') THEN
            SET Box(2,StrFmt("@SYS72494",'c5service'),0)
            RETURN "100"
        ENDIF
// SET &HR = COMAPI_MethodPut(&HCOM,&HCOM,'Open', 'VT_BSTR', 'GET',
//                                                'VT_BSTR', &IDATA,
//                                                'VT_BOOL', '0')
        SET COMPush(&HCOM, &HCOM)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'GET')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET COMPushVariant(&HCOM, 'VT_BOOL', '0')
        SET &HR = COMInvoke(&HCOM, 'Open', 3, 0)
        #ShowError(&HCOM,'COMInvoke,Open')
        IF &HR <> '' THEN
            RETURN "101"
        ENDIF
        RETURN "1"
    // 14.05.2014 GSL - Systemconnect

    #Case('HttpOpen')
        IF (&IDATA == '') THEN
            RETURN "0"
        ENDIF

        SET &HCOM = COMCreate(0,'MSXML2.XMLHTTP','',0)
        IF (&HCOM == '') THEN
            SET Box(2,StrFmt("@SYS72494",'c5service'),0)
            RETURN "100"
        ENDIF
// SET &HR = COMAPI_MethodPut(&HCOM,&HCOM,'Open', 'VT_BSTR', 'POST',
//                                                'VT_BSTR', &IDATA,
//                                                'VT_BOOL', '0')
        SET COMPush(&HCOM, &HCOM)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'POST')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET COMPushVariant(&HCOM, 'VT_BOOL', '0')
        SET &HR = COMInvoke(&HCOM, 'Open', 3, 0)
        #ShowError(&HCOM,'COMInvoke,Open')
        IF &HR <> '' THEN
            RETURN "101"
        ENDIF
        RETURN "1"

    #Case('HttpSetRequestHeaderType')
        IF (&HCOM == '') THEN
            RETURN "110"
        ENDIF
        //
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'RequestHeaderType')
        SET COMTop(&HCOM, 130)
        //
        SET COMPushVariant(&HCOM, 'VT_BSTR', '')
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'RequestHeaderValue')
        SET COMTop(&HCOM, 130)
        RETURN "1"

    #Case('HttpSetRequestHeaderValue')
        IF (&HCOM == '') THEN
            RETURN "111"
        ENDIF
        //
        SET COMPush(&HCOM, &HCOM)
        SET COMPush(&HCOM, 'RequestHeaderType')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET &HR = COMInvoke(&HCOM, 'setRequestHeader', 2, 0)
        #ShowError(&HCOM,'COMInvoke,setRequestHeader')
        IF &HR <> '' THEN
            RETURN "111"
        ENDIF
        RETURN "1"

    #Case('HttpNewRequestStr')
        IF (&HCOM == '') THEN
            RETURN "120"
        ENDIF
        //
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'RequestStr')
        SET COMTop(&HCOM, 130)
        RETURN "1"

    #Case('HttpAddRequestStr')
        IF (&HCOM == '') THEN
            RETURN "121"
        ENDIF
        //
        SET COMPush(&HCOM, 'RequestStr')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET COMCmd(&HCOM, 'bstr.concat', 2, 0)
        #ShowError(&HCOM,'COMCmd,bstr.concat')
        IF &HR <> '' THEN
            RETURN "121"
        ENDIF
        RETURN "1"

    #Case('HttpEndRequestStr')
        IF (&HCOM == '') THEN
            RETURN "122"
        ENDIF
        //
        SET &HDomDocument = COMCreate(0,'MSXML2.DomDocument','',0)
        IF (&HDomDocument == '') THEN
            SET Box(2,StrFmt("@SYS72494",'C5Service'),0)
            RETURN "122"
        ENDIF
        SET COMPush(&HCOM, &HDomDocument)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'HDomDocument')
        SET COMTop(&HCOM, 130)
        //
        SET COMPush(&HCOM, 'HDomDocument')
        SET COMPush(&HCOM, 'RequestStr')
        SET &HR = COMInvoke(&HCOM, 'LoadXML', 1, 0)
        #ShowError(&HCOM,'COMInvoke,LoadXML')
        IF &HR <> '' THEN
            RETURN "122"
        ENDIF
        RETURN "1"


    #Case('HttpSend')
        IF (&HCOM == '') THEN
            RETURN "140"
        ENDIF

        // Load
        SET &HR = COMPush(&HCOM, 'HDomDocument')
        IF &HR <> '' THEN
            SET &HDomDocument = COMCreate(0,'MSXML2.DomDocument','',0)
            IF (&HDomDocument == '') THEN
                SET Box(2,StrFmt("@SYS72494",'C5Service'),0)
                RETURN "140"
            ENDIF
            SET COMPush(&HCOM, &HDomDocument)
            SET COMPushVariant(&HCOM, 'VT_BSTR', 'HDomDocument')
            SET COMTop(&HCOM, 129)
        ENDIF

        // responsexml
        SET COMPush(&HCOM, &HCOM)
        // Send
        SET COMPush(&HCOM, &HCOM)

        //
        SEt COMPush(&HCOM, 'HDomDocument')
        SET &HR = COMGet(&HCOM, 'xml', 0)
        #ShowError(&HCOM,'COMGet,xml')
        IF &HR <> '' THEN
            RETURN "130"
        ENDIF

        //
        SET &HR = COMInvoke(&HCOM, 'Send', 1, 0)
        #ShowError(&HCOM,'COMInvoke,Send')
        IF &HR <> '' THEN
            RETURN "130"
        ENDIF

        //
        SET &HR = COMGet(&HCOM, 'responseXML', 0)
        #ShowError(&HCOM,'COMGet,responseXML')
        IF &HR <> '' THEN
            RETURN "130"
        ENDIF
        //
        SET &HR = COMInvoke(&HCOM, 'Load', 1, 1)
        #ShowError(&HCOM,'COMInvoke,Load')
        IF &HR <> '' THEN
            RETURN "131"
        ENDIF
        SET COMTopVariant(&HCOM,2)
        RETURN "1"

    #Case('XMLFileLoad')
        IF (&HCOM == '') THEN
            RETURN "140"
        ENDIF
        //
        SET &HDomDocument = COMCreate(0,'MSXML2.DomDocument','',0)
        IF (&HDomDocument == '') THEN
            SET Box(2,StrFmt("@SYS72494",'C5Service'),0)
            RETURN "140"
        ENDIF
        SET COMPush(&HCOM, &HDomDocument)
        SET COMPushVariant(&HCOM, 'VT_BSTR', 'HDomDocument')
        SET COMTop(&HCOM, 130)

        // Load
        SET COMPush(&HCOM, 'HDomDocument')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET &HR = COMInvoke(&HCOM, 'Load', 1, 1)
        #ShowError(&HCOM,'COMInvoke,Load')
        IF &HR <> '' THEN
            RETURN "141"
        ENDIF
        IF (COMTopVariant(&HCOM, 2) <> "-1") THEN
            RETURN "141"
        ENDIF
        RETURN "1"


    #Case('XMLFileSave')
        IF (&HCOM == '') THEN
            RETURN "142"
        ENDIF

        // Save
        SET &HR = COMPush(&HCOM, 'HDomDocument')
        #ShowError(&HCOM,'COMPush,HDomDocument')
        SET COMPushVariant(&HCOM, 'VT_BSTR', &IDATA)
        SET &HR = COMInvoke(&HCOM, 'Save', 1, 0)
        #ShowError(&HCOM,'COMInvoke,Save')
        IF &HR <> '' THEN
            RETURN "142"
        ENDIF
        RETURN "1"


    #Case('C5ServiceDone')
        IF (&HCOM == '') THEN
            RETURN "1"
        ENDIF
        SET COMPush(&HCOM, 'HDomDocument')
        SET &HDomDocument = COMTop(&HCOM, 2)
        SET COMRelease(&HDomDocument)

        SET COMRelease(&HCOM)
        SET &HCOM = ''
        RETURN "1"

    ELSE
        PRINT &CMD+" is an invalid operation"

    #EndSwitch
RETURN "0"